/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /builds/moz2_slave/mozilla-central-linux64-xulrunner/build/dom/interfaces/core/nsIDOMNSElement.idl
 */

package org.mozilla.interfaces;

public interface nsIDOMNSElement extends nsISupports {

  String NS_IDOMNSELEMENT_IID =
    "{d894b5d4-44f3-422a-a220-7763c12d4a94}";

  nsIDOMNodeList getElementsByClassName(String classes);

  nsIDOMClientRectList getClientRects();

  /**
   * Returns the union of all rectangles in the getClientRects() list. Empty
   * rectangles are ignored, except that if all rectangles are empty,
   * we return an empty rectangle positioned at the top-left of the first
   * rectangle in getClientRects().
   */
  nsIDOMClientRect getBoundingClientRect();

  /**
   * The vertical scroll position of the element, or 0 if the element is not
   * scrollable. This property may be assigned a value to change the
   * vertical scroll position.
   */
  int getScrollTop();

  /**
   * The vertical scroll position of the element, or 0 if the element is not
   * scrollable. This property may be assigned a value to change the
   * vertical scroll position.
   */
  void setScrollTop(int aScrollTop);

  /**
   * The horizontal scroll position of the element, or 0 if the element is not
   * scrollable. This property may be assigned a value to change the
   * horizontal scroll position.
   */
  int getScrollLeft();

  /**
   * The horizontal scroll position of the element, or 0 if the element is not
   * scrollable. This property may be assigned a value to change the
   * horizontal scroll position.
   */
  void setScrollLeft(int aScrollLeft);

  /**
   * The height of the scrollable area of the element. If the element is not
   * scrollable, scrollHeight is equivalent to the offsetHeight.
   */
  int getScrollHeight();

  /**
   * The width of the scrollable area of the element. If the element is not
   * scrollable, scrollWidth is equivalent to the offsetWidth.
   */
  int getScrollWidth();

  /**
   * The height in CSS pixels of the element's top border.
   */
  int getClientTop();

  /**
   * The width in CSS pixels of the element's left border and scrollbar
   * if it is present on the left side.
   */
  int getClientLeft();

  /**
   * The width in CSS pixels of the element's padding box. If the element is
   * scrollable, the scroll bars are included inside this height.
   */
  int getClientHeight();

  /**
   * The height in CSS pixels of the element's padding box. If the element is
   * scrollable, the scroll bars are included inside this width.
   */
  int getClientWidth();

  /**
   * Similar as the attributes on nsIDOMNode, but navigates just elements
   * rather than all nodes.
   *
   * Defined by the ElementTraversal spec.
   */
  nsIDOMElement getFirstElementChild();

  nsIDOMElement getLastElementChild();

  nsIDOMElement getPreviousElementSibling();

  nsIDOMElement getNextElementSibling();

  /**
   * Returns the number of child nodes that are nsIDOMElements.
   *
   * Defined by the ElementTraversal spec.
   */
  long getChildElementCount();

  /**
   * Returns a live nsIDOMNodeList of the current child elements.
   */
  nsIDOMNodeList getChildren();

  /**
   * Returns a DOMTokenList object reflecting the class attribute.
   */
  nsIDOMDOMTokenList getClassList();

  /**
   * Set this during a mousedown event to grab and retarget all mouse events
   * to this element until the mouse button is released or releaseCapture is
   * called. If retargetToElement is true, then all events are targetted at
   * this element. If false, events can also fire at descendants of this
   * element.
   * 
   */
  void setCapture(boolean retargetToElement);

  /**
   * If this element has captured the mouse, release the capture. If another
   * element has captured the mouse, this method has no effect.
   */
  void releaseCapture();

  /**
   * Returns whether this element would be selected by the given selector string.
   */
  boolean mozMatchesSelector(String selector);

}