/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /builds/moz2_slave/mozilla-central-linux64-xulrunner/build/xpcom/base/nsIDebug.idl
 */

package org.mozilla.interfaces;

/**
 * @status FROZEN
 *   For use by consumers in scripted languages (JavaScript, Java, Python,
 *   Perl, ...).
 *
 * @note C/C++ consumers who are planning to use the nsIDebug interface with
 *   the "@mozilla.org/xpcom;1" contract should use NS_DebugBreak from xpcom
 *   glue instead.
 *
 */
public interface nsIDebug extends nsISupports {

  String NS_IDEBUG_IID =
    "{3bf0c3d7-3bd9-4cf2-a971-33572c503e1e}";

  /**
   * Show an assertion and trigger nsIDebug.break().
   *
   * @param aStr assertion message
   * @param aExpr expression that failed
   * @param aFile file containing assertion
   * @param aLine line number of assertion
   *
   */
  void assertion(String aStr, String aExpr, String aFile, int aLine);

  /**
   * Show a warning.
   *
   * @param aStr warning message
   * @param aFile file containing assertion
   * @param aLine line number of assertion
   */
  void warning(String aStr, String aFile, int aLine);

  /**
   * Request to break into a debugger.
   *
   * @param aFile file containing break request
   * @param aLine line number of break request
   */
  void _break(String aFile, int aLine);

  /**
   * Request the process to trigger a fatal abort.
   *
   * @param aFile file containing abort request
   * @param aLine line number of abort request
   */
  void abort(String aFile, int aLine);

}